# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetTlsPlatformCertificateIdsResult',
    'AwaitableGetTlsPlatformCertificateIdsResult',
    'get_tls_platform_certificate_ids',
    'get_tls_platform_certificate_ids_output',
]

@pulumi.output_type
class GetTlsPlatformCertificateIdsResult:
    """
    A collection of values returned by getTlsPlatformCertificateIds.
    """
    def __init__(__self__, id=None, ids=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if ids and not isinstance(ids, list):
            raise TypeError("Expected argument 'ids' to be a list")
        pulumi.set(__self__, "ids", ids)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def ids(self) -> Sequence[str]:
        """
        List of IDs corresponding to Platform TLS certificates.
        """
        return pulumi.get(self, "ids")


class AwaitableGetTlsPlatformCertificateIdsResult(GetTlsPlatformCertificateIdsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTlsPlatformCertificateIdsResult(
            id=self.id,
            ids=self.ids)


def get_tls_platform_certificate_ids(opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTlsPlatformCertificateIdsResult:
    """
    Use this data source to get the IDs of available Platform TLS Certificates for use with other resources.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_fastly as fastly

    example = fastly.get_tls_platform_certificate_ids()
    example_get_tls_platform_certificate = fastly.get_tls_platform_certificate(id=example.ids[0])
    ```
    """
    __args__ = dict()
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('fastly:index/getTlsPlatformCertificateIds:getTlsPlatformCertificateIds', __args__, opts=opts, typ=GetTlsPlatformCertificateIdsResult).value

    return AwaitableGetTlsPlatformCertificateIdsResult(
        id=pulumi.get(__ret__, 'id'),
        ids=pulumi.get(__ret__, 'ids'))
def get_tls_platform_certificate_ids_output(opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetTlsPlatformCertificateIdsResult]:
    """
    Use this data source to get the IDs of available Platform TLS Certificates for use with other resources.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_fastly as fastly

    example = fastly.get_tls_platform_certificate_ids()
    example_get_tls_platform_certificate = fastly.get_tls_platform_certificate(id=example.ids[0])
    ```
    """
    __args__ = dict()
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('fastly:index/getTlsPlatformCertificateIds:getTlsPlatformCertificateIds', __args__, opts=opts, typ=GetTlsPlatformCertificateIdsResult)
    return __ret__.apply(lambda __response__: GetTlsPlatformCertificateIdsResult(
        id=pulumi.get(__response__, 'id'),
        ids=pulumi.get(__response__, 'ids')))
